Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms.Grid
Imports System.Collections.Specialized
Imports Syncfusion.Windows.Forms.Grid.Grouping
Imports Syncfusion.Grouping

Namespace GGC_Grouping_Table
	Partial Public Class Form1
		Inherits Form
		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
			Me.gridGroupingControl1.DataSource = GetTable()
			Me.gridGroupingControl1.ShowGroupDropArea =True
			Me.gridGroupingControl1.TableModel.BaseStylesMap("Standared").StyleInfo.CellType = "TextBox"
			AddHandler gridGroupingControl1.QueryCellStyleInfo, AddressOf gridGroupingControl1_QueryCellStyleInfo

			AddHandler gridGroupingControl1.TableControlCurrentCellEditingComplete, AddressOf gridGroupingControl1_TableControlCurrentCellEditingComplete


		End Sub

		Private Sub gridGroupingControl1_TableControlCurrentCellEditingComplete(ByVal sender As Object, ByVal e As GridTableControlEventArgs)
			Dim rec As Record = Me.gridGroupingControl1.Table.DisplayElements(e.TableControl.CurrentCell.RowIndex).ParentRecord
			'GridTableCellStyleInfo sty = this.gridGroupingControl1.TableControl.GetTableViewStyleInfo(e.TableControl.CurrentCell.RowIndex, e.TableControl.CurrentCell.ColIndex);
			'MessageBox.Show(sty.TableCellIdentity.DisplayElement.GetRecord().GetValue("Col1").ToString());
			MessageBox.Show(rec.GetValue("Col1").ToString())
		End Sub



		Private Sub gridGroupingControl1_QueryCellStyleInfo(ByVal sender As Object, ByVal e As GridTableCellStyleInfoEventArgs)
			If e.TableCellIdentity.TableCellType<>GridTableCellType.ColumnHeaderCell AndAlso e.TableCellIdentity.Column IsNot Nothing AndAlso e.TableCellIdentity.Column.Name = "Col1" Then
				e.Style.CellType = "MaskEdit"
			   e.Style.ReadOnly = False
				e.Style.Format = "MM-dd-yyyy"
				e.Style.MaskEdit.Mask = "99-99-9999"
			End If
		End Sub

		#Region "DataTable"
		Public Function GetTable() As DataTable
			Dim dt As New DataTable("Details")
			Dim nRows As Integer = 20
			For i As Integer = 0 To 7
				dt.Columns.Add(New DataColumn("Col" & i))
			Next i

			Dim r As New Random()
			For i As Integer = 0 To nRows - 1
				Dim dr As DataRow = dt.NewRow()
				For j As Integer = 0 To 7
					If j = 1 Then
						dr(j) = 15081987
					ElseIf j Mod 100 = 0 Then
						dr(j) = i \ 50
					ElseIf j Mod 2 = 0 Then
						dr(j) = r.Next(255) Mod 8
					Else
						dr(j) = r.Next(333) Mod 6
					End If
				Next j
				dt.Rows.Add(dr)
			Next i
			Return dt
		End Function
		#End Region
	End Class
End Namespace